From afb748bbd8188eefb432ad67c647a27d0e9f7cab Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 13:36:29 +0000
Subject: [PATCH 5/51] add detail decorator


This allows pointing out what should be examined further, e.g. which
part of a guideline may have been violated.

---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index b2c62ea..48941ac 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -49,6 +49,17 @@ warning = LintLevelDecorator("warning")
 error = LintLevelDecorator("error")
 
 
+class detail(object):
+    """Decorate a linter method with details about what needs to be fixed."""
+
+    def __init__(self, detail):
+        self.detail = detail
+
+    def __call__(self, fn):
+        fn.lint_detail = self.detail
+        return fn
+
+
 class ModuleMDLinter(object):
     """Linter for modulemd YAML files or data."""
 
@@ -89,19 +100,29 @@ class ModuleMDLinter(object):
             try:
                 method()
             except Exception as e:
+                try:
+                    lint_detail = method.lint_detail
+                except AttributeError:
+                    lint_detail = None
                 flagged.append((method.lint_level, inspect.getdoc(method),
-                                method.lint_guidelines_url, e))
+                                lint_detail, method.lint_guidelines_url, e))
 
         longest_level_len = reduce(lambda x, y: max(x, len(y)),
                                    LintLevelDecorator.all_levels, 0)
 
-        for i, (lvl, text, url, exc) in enumerate(flagged):
+        for i, (lvl, text, detail, url, exc) in enumerate(flagged):
             print("[{lvl: <{len}}] {url}".format(lvl=lvl,
                                                  len=longest_level_len,
                                                  url=url or ""))
             for l in text.split("\n"):
                 print("\t" + l)
 
+            if detail:
+                print()
+                print("\tDETAIL:")
+                for l in detail.split("\n"):
+                    print("\t" + l)
+
             if i < len(flagged) - 1:
                 print()
 

